/*
	SambaScanner - A tool to scan Samba networks for files.
	Copyright (C) 2005-2007 Johannes Bauer
	
	This file is part of SambaScanner.

    SambaScanner is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; this program is ONLY licensed under
	version 2 of the License, later versions are explicitly excluded.

    SambaScanner is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with SambaScanner; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Johannes Bauer
	Mussinanstr. 140
	92318 Neumarkt/Opf.
	JohannesBauer@gmx.de
*/

#include "config.h"

#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <signal.h>
#include <sys/wait.h>
#include <time.h>
#include <pthread.h>
#include <sys/timeb.h>

#include "String.h"
#include "Mutex.h"
#include "Parser.h"

#define USE_THREADS				200
#define CONCURRENT_THREADS		20

void* TestThread(void *Argument) {
	int i;
	ThreadCnt_Inc();
	i = (rand() % 1000) + 100;
	printf("-> Started testthread %d [sleep %d]\n", (int)Argument, i);
	usleep(1000 * i);
	printf("<- Exited testthread %d [sleep %d]\n", (int)Argument, i);
	ThreadCnt_Dec();
	return NULL;
}

int main(int argc, char **argv) {
	int i;
	pthread_t Threads[USE_THREADS];

	printf("Checking semaphores...\n");
	Init_Semaphores(CONCURRENT_THREADS);

	for (i = 0; i < USE_THREADS; i++) {
		printf("init thread i = %d\n", i);
		pthread_create(&Threads[i], NULL, TestThread, (void*)i);
	}

	printf("End of loop!\n");
	printf("Waiting for termination...\n");
	for (i = 0; i < CONCURRENT_THREADS; i++) {
		ThreadCnt_Inc();
	}
	printf("Waiting for termination finished!\n");
	while (1) {
		printf("Any messages after this are BAD!\n");
		sleep(1);
	}
	
	return 0;
}
